import React from 'react'
import * as Fiber from '@react-three/fiber'
import * as Three from 'three'

const ThreeBox:React.FC<{position?:Fiber.Vector3}> =(args)=> {
  const meshRef = React.useRef<Three.Mesh>(null)
  const [hovered, setHover] = React.useState(false)
  const [active, setActive] = React.useState(false)
  Fiber.useFrame((_state, delta) => meshRef.current&&(meshRef.current.rotation.x += delta))
  return <mesh
    position={args.position}
    ref={meshRef}
    scale={active ? 1.5 : 1}
    onClick={_=> setActive(!active)}
    onPointerOver={_=> setHover(true)}
    onPointerOut ={_=> setHover(false)}>
    <boxGeometry args={[1, 1, 1]} />
    <meshStandardMaterial color={hovered ? 'hotpink' : 'orange'} />
  </mesh>
}

const ThreeStage:React.FC =()=> <Fiber.Canvas>
  <ambientLight intensity={Math.PI / 2} />
  <spotLight position={[10, 10, 10]} angle={0.15} penumbra={1} decay={0} intensity={Math.PI} />
  <pointLight position={[-10, -10, -10]} decay={0} intensity={Math.PI} />
  <ThreeBox position={[-1.2, 0, 0]} />
  <ThreeBox position={[1.2, 0, 0]} />
</Fiber.Canvas>;


export default function App() {
  const [count, setCount] = React.useState(0)
  return <>
    <button onClick={() => setCount((count) => count + 1)}>
      le count {count}
    </button>
    <ThreeStage/>
  </>;
}